// Made with Blockbench 4.12.3
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelqueenbee<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "queenbee"), "main");
	private final ModelPart body;
	private final ModelPart bone;
	private final ModelPart wing;
	private final ModelPart wing2;
	private final ModelPart leg2;
	private final ModelPart leg1;
	private final ModelPart leg3;

	public Modelqueenbee(ModelPart root) {
		this.body = root.getChild("body");
		this.bone = this.body.getChild("bone");
		this.wing = this.body.getChild("wing");
		this.wing2 = this.body.getChild("wing2");
		this.leg2 = this.body.getChild("leg2");
		this.leg1 = this.body.getChild("leg1");
		this.leg3 = this.body.getChild("leg3");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition body = partdefinition.addOrReplaceChild("body", CubeListBuilder.create().texOffs(0, 25)
				.addBox(-2.0F, -1.0F, -2.0F, 7.0F, 7.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-1.0F, 8.0F, -7.0F));

		PartDefinition body3_r1 = body.addOrReplaceChild("body3_r1",
				CubeListBuilder.create().texOffs(34, 25)
						.addBox(0.5F, -1.0F, 11.0F, 0.0F, 3.0F, 9.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(-4.0F, -4.0F, -1.0F, 9.0F, 9.0F, 16.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(1.0F, 1.4142F, 7.5858F, -0.7854F, 0.0F, 0.0F));

		PartDefinition bone = body.addOrReplaceChild("bone",
				CubeListBuilder.create().texOffs(14, 42)
						.addBox(-1.0F, -3.0F, -3.0F, 0.0F, 3.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(20, 42)
						.addBox(4.0F, -3.0F, -3.0F, 0.0F, 3.0F, 3.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -1.0F, 0.0F));

		PartDefinition wing = body.addOrReplaceChild("wing", CubeListBuilder.create().texOffs(-6, 49).addBox(-15.0F,
				0.0F, 10.0F, 12.0F, 0.0F, 6.0F, new CubeDeformation(0.0F)), PartPose.offset(0.0F, 0.0F, 0.0F));

		PartDefinition wing2 = body.addOrReplaceChild("wing2",
				CubeListBuilder.create().texOffs(-6, 49).addBox(-12.0F, 0.0F, -1.0F, 12.0F, 0.0F, 6.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(6.0F, 0.0F, 11.0F, 0.0F, 0.0F, -3.1416F));

		PartDefinition leg2 = body
				.addOrReplaceChild("leg2",
						CubeListBuilder.create().texOffs(34, 40).addBox(-3.0F, -1.0F, 0.0F, 7.0F, 3.0F, 0.0F,
								new CubeDeformation(0.0F)),
						PartPose.offsetAndRotation(1.0F, 8.0F, 6.0F, -0.3491F, 0.0F, 0.0F));

		PartDefinition leg1 = body.addOrReplaceChild("leg1", CubeListBuilder.create().texOffs(34, 37).addBox(-3.0F,
				-16.0F, 1.0F, 7.0F, 3.0F, 0.0F, new CubeDeformation(0.0F)), PartPose.offset(1.0F, 22.0F, 3.0F));

		PartDefinition leg3 = body.addOrReplaceChild("leg3",
				CubeListBuilder.create().texOffs(0, 42).addBox(-3.0F, 0.0F, 1.0F, 7.0F, 3.0F, 0.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(1.0F, 8.684F, 7.8794F, -0.3491F, 0.0F, 0.0F));

		return LayerDefinition.create(meshdefinition, 64, 64);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
	}
}