
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.iwosmobs.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.entity.EntityAttributeCreationEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;

import net.mcreator.iwosmobs.entity.LivingflowerEntity;
import net.mcreator.iwosmobs.entity.FlytrapEntity;
import net.mcreator.iwosmobs.entity.EatingflowerEntity;
import net.mcreator.iwosmobs.IwosMobsMod;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class IwosMobsModEntities {
	public static final DeferredRegister<EntityType<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.ENTITY_TYPES, IwosMobsMod.MODID);
	public static final RegistryObject<EntityType<LivingflowerEntity>> LIVINGFLOWER = register("livingflower",
			EntityType.Builder.<LivingflowerEntity>of(LivingflowerEntity::new, MobCategory.CREATURE).setShouldReceiveVelocityUpdates(true).setTrackingRange(24).setUpdateInterval(3).setCustomClientFactory(LivingflowerEntity::new)

					.sized(0.6f, 0.6f));
	public static final RegistryObject<EntityType<EatingflowerEntity>> EATINGFLOWER = register("eatingflower",
			EntityType.Builder.<EatingflowerEntity>of(EatingflowerEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(EatingflowerEntity::new)

					.sized(0.6f, 1.8f));
	public static final RegistryObject<EntityType<FlytrapEntity>> FLYTRAP = register("flytrap",
			EntityType.Builder.<FlytrapEntity>of(FlytrapEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(FlytrapEntity::new)

					.sized(0.6f, 1.8f));
	public static final RegistryObject<EntityType<QueenbeeEntity>> QUEENBEE = register("queenbee",
			EntityType.Builder.<QueenbeeEntity>of(QueenbeeEntity::new, MobCategory.CREATURE).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(QueenbeeEntity::new)

					.sized(0.6f, 1.8f));

	// Start of user code block custom entities
	// End of user code block custom entities
	private static <T extends Entity> RegistryObject<EntityType<T>> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		return REGISTRY.register(registryname, () -> (EntityType<T>) entityTypeBuilder.build(registryname));
	}

	@SubscribeEvent
	public static void init(FMLCommonSetupEvent event) {
		event.enqueueWork(() -> {
			LivingflowerEntity.init();
			EatingflowerEntity.init();
			FlytrapEntity.init();
			QueenbeeEntity.init();
		});
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(LIVINGFLOWER.get(), LivingflowerEntity.createAttributes().build());
		event.put(EATINGFLOWER.get(), EatingflowerEntity.createAttributes().build());
		event.put(FLYTRAP.get(), FlytrapEntity.createAttributes().build());
		event.put(QUEENBEE.get(), QueenbeeEntity.createAttributes().build());
	}
}
