
package net.mcreator.iwosmobs.item;

import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.Tier;
import net.minecraft.world.item.SwordItem;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.entity.LivingEntity;

import net.mcreator.iwosmobs.procedures.SpikeswordLivingEntityIsHitWithToolProcedure;
import net.mcreator.iwosmobs.init.IwosMobsModItems;

public class SpikeswordItem extends SwordItem {
	public SpikeswordItem() {
		super(new Tier() {
			public int getUses() {
				return 70;
			}

			public float getSpeed() {
				return 4f;
			}

			public float getAttackDamageBonus() {
				return 1f;
			}

			public int getLevel() {
				return 3;
			}

			public int getEnchantmentValue() {
				return 5;
			}

			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(IwosMobsModItems.FLOWERSPIKE.get()));
			}
		}, 3, -2.8f, new Item.Properties());
	}

	@Override
	public boolean hurtEnemy(ItemStack itemstack, LivingEntity entity, LivingEntity sourceentity) {
		boolean retval = super.hurtEnemy(itemstack, entity, sourceentity);
		SpikeswordLivingEntityIsHitWithToolProcedure.execute(entity);
		return retval;
	}
}
